import itertools
import random
from typing import Any, Self, Sequence

from .config import get_config


class Random(random.Random):
    @classmethod
    async def get(cls, bonus_salt: Any = "") -> Self:
        cfg = await get_config()
        return cls(f"{cfg.puzzle.solution}{cfg.puzzle.random_seed}{bonus_salt}")


async def shuffle(seq: Sequence, rnd: random.Random | None = None) -> list:
    # Zufallsgenerator
    rnd = rnd or await Random.get()

    # Elemente mischen
    return rnd.sample(seq, len(seq))


def set_len(seq: Sequence, length: int) -> list:
    # `seq` unendlich wiederholen
    infinite = itertools.cycle(seq)

    # Die ersten `length` einträge nehmen
    return list(itertools.islice(infinite, length))
